/*
 * Copyright (C) 2005 Johan Maasing johan at zoom.nu Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package nu.zoom.swing.desktop.plugin.portunis;

import java.io.File;
import java.util.ArrayList;

import nu.zoom.swing.desktop.common.BackendException;

/**
 * Used by the keystore plug-in to store & retrieve GUI preferences.
 * 
 * @version $Revision: 1.2 $
 * @author $Author: johan $
 */
public interface ApplicationPreferences
{

	/**
	 * NOT IMPLEMENTED YET
	 * 
	 * @return A list of keystores that was previously loaded.
	 * @throws BackendException
	 */
	public ArrayList<File> getRememberedKeyStores() throws BackendException;

	/**
	 * NOT IMPLEMENTED YET
	 * 
	 * @param file
	 *            The keystore that we want to remeber was opened.
	 * @throws BackendException
	 */
	public void rememberKeyStore(File file) throws BackendException;

	/**
	 * NOT IMPLEMENTED YET
	 * 
	 * @param file
	 *            The keystore that we want to forget was previously loaded.
	 * @throws BackendException
	 */
	public void forgetKeyStore(File file) throws BackendException;

	/**
	 * Get the previous directory the user opened a file from.
	 * 
	 * @return The directory name.
	 * @throws BackendException
	 */
	public String getFileChooserStartDirectory() throws BackendException;

	/**
	 * Remember a directory the user opened files from.
	 * 
	 * @param string
	 *            The directory name.
	 * @throws BackendException
	 */
	public void setFileChooserStartDirectory(String string)
			throws BackendException;
}
